"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ScrollTypeEnum;
(function (ScrollTypeEnum) {
    ScrollTypeEnum["Before"] = "SCROLL_BEFORE";
    ScrollTypeEnum["After"] = "SCROLL_AFTER";
})(ScrollTypeEnum = exports.ScrollTypeEnum || (exports.ScrollTypeEnum = {}));
var getRange = function (manager, scrollPosition, size, overscanCount, scrollType) {
    var startIndex = manager.getIndexByPixel(scrollPosition);
    var startOverscan = scrollType === ScrollTypeEnum.Before ? overscanCount : 0;
    var start = Math.max(startIndex - startOverscan, 0);
    var endIndex = manager.getIndexByPixel(scrollPosition + size);
    var endOverscan = scrollType === ScrollTypeEnum.After ? overscanCount : 0;
    var end = Math.min(endIndex + endOverscan, manager.count - 1);
    return { start: start, end: end };
};
var RenderRangesManager = /** @class */ (function () {
    function RenderRangesManager() {
        var _this = this;
        this.getRowsRange = function (rowManager, scrollTop, height, overscanRowCount, rowScrollType) {
            var _a = getRange(rowManager, scrollTop, height, overscanRowCount, rowScrollType), start = _a.start, end = _a.end;
            if (!_this.rowsRange || _this.rowsRange.start !== start || _this.rowsRange.end !== end) {
                _this.rowsRange = { start: start, end: end };
            }
            return _this.rowsRange;
        };
        this.getColumnsRange = function (columnManager, scrollLeft, width, overscanColumnCount, columnScrollType) {
            var _a = getRange(columnManager, scrollLeft, width, overscanColumnCount, columnScrollType), start = _a.start, end = _a.end;
            if (!_this.columnsRange || _this.columnsRange.start !== start || _this.columnsRange.end !== end) {
                _this.columnsRange = { start: start, end: end };
            }
            return _this.columnsRange;
        };
    }
    return RenderRangesManager;
}());
exports.default = RenderRangesManager;
